// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rmf_task_msgs:msg/Delivery.idl
// generated code does not contain a copyright notice

#ifndef RMF_TASK_MSGS__MSG__DETAIL__DELIVERY__TRAITS_HPP_
#define RMF_TASK_MSGS__MSG__DETAIL__DELIVERY__TRAITS_HPP_

#include "rmf_task_msgs/msg/detail/delivery__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'items'
#include "rmf_dispenser_msgs/msg/detail/dispenser_request_item__traits.hpp"
// Member 'pickup_behavior'
// Member 'dropoff_behavior'
#include "rmf_task_msgs/msg/detail/behavior__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const rmf_task_msgs::msg::Delivery & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: task_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "task_id: ";
    value_to_yaml(msg.task_id, out);
    out << "\n";
  }

  // member: items
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.items.size() == 0) {
      out << "items: []\n";
    } else {
      out << "items:\n";
      for (auto item : msg.items) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: pickup_place_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pickup_place_name: ";
    value_to_yaml(msg.pickup_place_name, out);
    out << "\n";
  }

  // member: pickup_dispenser
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pickup_dispenser: ";
    value_to_yaml(msg.pickup_dispenser, out);
    out << "\n";
  }

  // member: pickup_behavior
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pickup_behavior:\n";
    to_yaml(msg.pickup_behavior, out, indentation + 2);
  }

  // member: dropoff_place_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dropoff_place_name: ";
    value_to_yaml(msg.dropoff_place_name, out);
    out << "\n";
  }

  // member: dropoff_ingestor
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dropoff_ingestor: ";
    value_to_yaml(msg.dropoff_ingestor, out);
    out << "\n";
  }

  // member: dropoff_behavior
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dropoff_behavior:\n";
    to_yaml(msg.dropoff_behavior, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const rmf_task_msgs::msg::Delivery & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<rmf_task_msgs::msg::Delivery>()
{
  return "rmf_task_msgs::msg::Delivery";
}

template<>
inline const char * name<rmf_task_msgs::msg::Delivery>()
{
  return "rmf_task_msgs/msg/Delivery";
}

template<>
struct has_fixed_size<rmf_task_msgs::msg::Delivery>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rmf_task_msgs::msg::Delivery>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rmf_task_msgs::msg::Delivery>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RMF_TASK_MSGS__MSG__DETAIL__DELIVERY__TRAITS_HPP_
