// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rmf_task_msgs:srv/GetTaskList.idl
// generated code does not contain a copyright notice

#ifndef RMF_TASK_MSGS__SRV__DETAIL__GET_TASK_LIST__TRAITS_HPP_
#define RMF_TASK_MSGS__SRV__DETAIL__GET_TASK_LIST__TRAITS_HPP_

#include "rmf_task_msgs/srv/detail/get_task_list__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const rmf_task_msgs::srv::GetTaskList_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: requester
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "requester: ";
    value_to_yaml(msg.requester, out);
    out << "\n";
  }

  // member: task_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.task_id.size() == 0) {
      out << "task_id: []\n";
    } else {
      out << "task_id:\n";
      for (auto item : msg.task_id) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const rmf_task_msgs::srv::GetTaskList_Request & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<rmf_task_msgs::srv::GetTaskList_Request>()
{
  return "rmf_task_msgs::srv::GetTaskList_Request";
}

template<>
inline const char * name<rmf_task_msgs::srv::GetTaskList_Request>()
{
  return "rmf_task_msgs/srv/GetTaskList_Request";
}

template<>
struct has_fixed_size<rmf_task_msgs::srv::GetTaskList_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rmf_task_msgs::srv::GetTaskList_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rmf_task_msgs::srv::GetTaskList_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'active_tasks'
// Member 'terminated_tasks'
#include "rmf_task_msgs/msg/detail/task_summary__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const rmf_task_msgs::srv::GetTaskList_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: active_tasks
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.active_tasks.size() == 0) {
      out << "active_tasks: []\n";
    } else {
      out << "active_tasks:\n";
      for (auto item : msg.active_tasks) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: terminated_tasks
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.terminated_tasks.size() == 0) {
      out << "terminated_tasks: []\n";
    } else {
      out << "terminated_tasks:\n";
      for (auto item : msg.terminated_tasks) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const rmf_task_msgs::srv::GetTaskList_Response & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<rmf_task_msgs::srv::GetTaskList_Response>()
{
  return "rmf_task_msgs::srv::GetTaskList_Response";
}

template<>
inline const char * name<rmf_task_msgs::srv::GetTaskList_Response>()
{
  return "rmf_task_msgs/srv/GetTaskList_Response";
}

template<>
struct has_fixed_size<rmf_task_msgs::srv::GetTaskList_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rmf_task_msgs::srv::GetTaskList_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rmf_task_msgs::srv::GetTaskList_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rmf_task_msgs::srv::GetTaskList>()
{
  return "rmf_task_msgs::srv::GetTaskList";
}

template<>
inline const char * name<rmf_task_msgs::srv::GetTaskList>()
{
  return "rmf_task_msgs/srv/GetTaskList";
}

template<>
struct has_fixed_size<rmf_task_msgs::srv::GetTaskList>
  : std::integral_constant<
    bool,
    has_fixed_size<rmf_task_msgs::srv::GetTaskList_Request>::value &&
    has_fixed_size<rmf_task_msgs::srv::GetTaskList_Response>::value
  >
{
};

template<>
struct has_bounded_size<rmf_task_msgs::srv::GetTaskList>
  : std::integral_constant<
    bool,
    has_bounded_size<rmf_task_msgs::srv::GetTaskList_Request>::value &&
    has_bounded_size<rmf_task_msgs::srv::GetTaskList_Response>::value
  >
{
};

template<>
struct is_service<rmf_task_msgs::srv::GetTaskList>
  : std::true_type
{
};

template<>
struct is_service_request<rmf_task_msgs::srv::GetTaskList_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rmf_task_msgs::srv::GetTaskList_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RMF_TASK_MSGS__SRV__DETAIL__GET_TASK_LIST__TRAITS_HPP_
